!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: xWndTbr.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
xwt_EnumerateWindow PROCEDURE(UNSIGNED hWnd,LONG lParam),BOOL,PASCAL
xwt_WindowsToolbar  PROCEDURE(STRING inSelfAddr)
xwt_MoreWindow      PROCEDURE(STRING inSelfAddr)
 END
 INCLUDE('xWndTbr.inc'),ONCE
! *********************************************************************************
xWindowsToolbarClass.Construct PROCEDURE
 code
 self.CWQ &= new typeChildWindowsQueue
 self.Translator &= new TranslatorClass
 self.Translator.Init()
! *********************************************************************************
xWindowsToolbarClass.Destruct PROCEDURE
 code
 if NOT self.CWQ &= NULL then dispose(self.CWQ).
 self.Translator.Kill()
 if NOT self.Translator &= NULL then dispose(self.Translator).
! *********************************************************************************
xWindowsToolbarClass.Run PROCEDURE(LONG hWnd,<TranslatorGroup inTG>)
 code
 if not omitted(3)
    self.Translator.AddTranslation(inTG)
 end

 self.hFrame=hWnd
 self.hMDIClient=self.FindMDIClient()                       !  MDI CLIENT
 if self.hMDIClient
    self.SetCallback(self.hMDIClient)                       !  MDI CLIENT
 end
 self.tThread=start(xwt_WindowsToolbar,25000,address(SELF)) !  
! *********************************************************************************
xWindowsToolbarClass.Kill  PROCEDURE
 code
 if self.hMDIClient then self.RemoveCallback().

 if self.tThread
    post(Event:CloseWindow,,self.tThread)
 end

 loop !   
    YIELD
    if self.tThread=0 then break.
 end

 if self.mThread
    post(Event:CloseWindow,,self.mThread)
 end

 loop !   
    YIELD
    if self.mThread=0 then break.
 end
! *********************************************************************************
xWindowsToolbarClass.FindMDIClient PROCEDURE
hMDIClient LONG
 code
 Err#=xwt_EnumChildWindows(self.hFrame,address(xwt_EnumerateWindow),address(hMDIClient))
 RETURN hMDIClient
! *********************************************************************************
xWindowsToolbarClass.CallBackProc  PROCEDURE(ULONG hWnd,ULONG Msg,ULONG wParam,LONG lParam)
wParamGroup       GROUP,OVER(wParam)
loword               USHORT
hiword               USHORT
                  END

RetAddr           LONG
 code
 case Msg
    of xwt_WM_PARENTNOTIFY                           ! /  
       RetAddr=PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
       case wParamGroup.loword
          of xwt_WM_CREATE                           !  
             if NOT BAND(xwt_WS_VISIBLE,xwt_GetWindowLong(lParam,xwt_GWL_STYLE))=xwt_WS_VISIBLE
                self.CWQ.hWnd = lParam                  !    
                add(self.CWQ)
                self.Timer=2
!                self.UpdateToolbar()
             end
          of xwt_WM_DESTROY                          !  
!             if NOT BAND(xwt_WS_VISIBLE,xwt_GetWindowLong(lParam,xwt_GWL_STYLE))=xwt_WS_VISIBLE
                self.CWQ.hWnd = lParam                  !    
                get(self.CWQ,self.CWQ.hWnd)
                if not errorcode()
                   delete(self.CWQ)
                end
                self.UpdateToolbar()
!             end
       end
       return(RetAddr)
     of xwt_WM_SIZE !  
        RetAddr=PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
        post(Event:Sized,,self.tThread)
        return(RetAddr)
     of xwt_WM_MOUSEACTIVATE
        RetAddr=PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
        self.ActivateWnd()
        return(RetAddr)
     of xwt_WM_MDIACTIVATE
        RetAddr=PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
        self.ActivateWnd()
        return(RetAddr)
     of xwt_WM_MDINEXT
        RetAddr=PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
        self.ActivateWnd()
        return(RetAddr)
 end
 return PARENT.CallBackProc(hWnd,Msg,wParam,lParam)
! *********************************************************************************
xWindowsToolbarClass.UpdateToolbar PROCEDURE
 code
 if self.tThread
    post(Event:xwt_Update,,self.tThread)
 end
xWindowsToolbarClass.ActivateWnd PROCEDURE
 code
 if self.tThread
    post(Event:xwt_ActivateWnd,,self.tThread)
 end
! *********************************************************************************
xWindowsToolbarClass.DefaultSettings  PROCEDURE()
 code
 self.WndIcon = ''
 self.OptionWidth = 150
 self.TbrIcon = '~xTbr.ico'
 self.MWIcon = '~xMoreWnd.ico'
 self.Docked = DOCK:Bottom
 self.hPrevWnd = 0
 self.mThread = 0
 self.SavePosition = TRUE
 self.IniFileName =''
 self.RightIndentFlag=TRUE
 self.WallpaperName = '~bg.bmp'
 self.WallpaperMode = Prop:Stretch
! *********************************************************************************
xWindowsToolbarClass.HideToolbar PROCEDURE
 code
 if self.tThread
    post(Event:xwt_HideWnd,,self.tThread)
 end
! *********************************************************************************
xWindowsToolbarClass.UnhideToolbar PROCEDURE
 code
 if self.tThread
    post(Event:xwt_UnhideWnd,,self.tThread)
 end
! *********************************************************************************
xwt_EnumerateWindow PROCEDURE(UNSIGNED hWnd,LONG lParam)
hMDIClient      LONG
cstrClassName   CSTRING(80)
 code
 if xwt_GetClassName(hWnd,address(cstrClassName),size(cstrClassName))
    if upper(clip(cstrClassName))='MDICLIENT'
       hMDIClient=hWnd
       xwt_memcpy(lParam,address(hMDIClient),4)
       RETURN FALSE
    end
 end
 RETURN TRUE
! *********************************************************************************
xwt_WindowsToolbar PROCEDURE(STRING inSelfAddr)
loc:WindowsList BYTE ! option-box

TWindow WINDOW,AT(,,185,16),FONT('MS Sans Serif',8,,FONT:regular),IMM,ALRT(EscKey),DOCK(DOCK:top+DOCK:bottom), |
         DOCKED(DOCK:bottom),TIMER(50),TOOLBOX,GRAY
       OPTION,AT(84,0,93,15),USE(loc:WindowsList),FULL
         RADIO('hided'),AT(90,2,29,11),USE(?loc:WindowsList:Hide),VALUE('0')
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:1)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:2)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:3)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:4)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:5)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:6)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:7)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:8)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:9)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:10)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:11)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:12)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:13)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:14)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:15)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:16)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:17)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:18)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:19)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:20)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:21)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:22)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:23)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:24)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:25)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:26)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:27)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:28)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:29)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:30)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:31)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:32)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:33)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:34)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:35)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:36)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:37)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:38)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:39)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:40)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:41)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:42)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:43)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:44)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:45)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:46)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:47)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:48)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:49)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:50)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:51)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:52)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:53)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:54)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:55)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:56)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:57)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:58)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:59)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:60)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:61)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:62)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:63)
         RADIO('visible'),AT(126,2,32,11),USE(?loc:WL:64)
       END
       BUTTON,AT(176,2,8,12),USE(?MoreWindows),FLAT,HIDE
       STRING('HidedString'),AT(14,4),USE(?HidedString)
       IMAGE,AT(0,0,5,16),USE(?Image),CENTERED
     END

xRefWTC      &xWindowsToolbarClass         !    
lpRect       LIKE(xwt_RECT)                !  
cstrCaption  CSTRING(256)                  !   

ChildWndList QUEUE                         !    
hWnd            LONG                       !  
FEQ             LONG                       !      
Position        LONG                       !     
Text            STRING(256)                !   
ICON            CSTRING(256)               !  
             END

OptionsList  QUEUE                         !   
FEQ             LONG
             END

TWindowMng   CLASS(WindowManager)                                !     
Init             PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent        PROCEDURE(),BYTE,PROC,DERIVED
ResizeToolbar    PROCEDURE                                       !  
GetSettings      PROCEDURE                                       !   
SetSettings      PROCEDURE                                       !   
CreateButtonText PROCEDURE(STRING inText,BYTE inFlagBold),STRING !  " "  
CreateButtons    PROCEDURE                                       !  "" 
MoreWindows      PROCEDURE                                       !   " "
ActivateWnd      PROCEDURE                                       !  
FillOptionsQueue PROCEDURE                                       !   
             END

 code
 xRefWTC &= (inSelfAddr)
 TWindowMng.Run()

! *******************************************************************************************************************
TWindowMng.ResizeToolbar  PROCEDURE
 code
 xwt_GetClientRect(xRefWTC.hFrame,address(lpRect))
 TWindow{Prop:Pixels}=TRUE
! TWindow{Prop:Width}=abs(lpRect.right-lpRect.left-10*xRefWTC.RightIndentFlag) ! 10  -   
 TWindow{Prop:Width}=abs(lpRect.right-lpRect.left-1)
  TWindow{Prop:Pixels}=FALSE
 TWindow $ ?MoreWindows{Prop:Xpos}=TWindow{Prop:Width}-11       !   " "     11  
 display()
! *******************************************************************************************************************
TWindowMng.GetSettings PROCEDURE
 code
 if xRefWTC.SavePosition
    Docked#=getini('TSETUP','Docked',,xRefWTC.IniFileName) !    
    if Docked#
       TWindow{Prop:Docked}=Docked#
    else
       TWindow{Prop:Docked}=xRefWTC.Docked
    end

    Xpos#=getini('TSETUP','Xpos',,xRefWTC.IniFileName)     !  
    Ypos#=getini('TSETUP','Ypos',,xRefWTC.IniFileName)
    if Xpos# and Xpos#<TWindow{Prop:Width}
       TWindow{Prop:Xpos}=Xpos#
    end
    if Ypos#
       TWindow{Prop:Ypos}=Ypos#
    end
 else
    TWindow{Prop:Docked}=xRefWTC.Docked
 end
! *******************************************************************************************************************
TWindowMng.SetSettings    PROCEDURE
 code
 if xRefWTC.SavePosition
    putini('TSETUP','Docked',TWindow{Prop:Docked},xRefWTC.IniFileName)
    putini('TSETUP','Xpos',TWindow{Prop:Xpos},xRefWTC.IniFileName)
    putini('TSETUP','Ypos',TWindow{Prop:Ypos},xRefWTC.IniFileName)
 end
! *******************************************************************************************************************
TWindowMng.CreateButtonText PROCEDURE(STRING inText,BYTE inFlagBold)
ReturnValue  STRING(1024) ! ""   
 code
 if len(clip(xRefWTC.WndIcon))
    FlagIcon#=1
 else
    FlagIcon#=0
 end
 TWindow $?HidedString{Prop:Xpos}=0
 TWindow $?HidedString{Prop:Ypos}=0
 TWindow $?HidedString{Prop:Text}=clip(inText)
 if inFlagBold
    TWindow $?HidedString{Prop:Font,4}=Font:Bold
 else
    TWindow $?HidedString{Prop:Font,4}=Font:Regular
 end
 FlagTrunc#=FALSE
 loop
    if TWindow $?HidedString{Prop:Text}='...' then break.
    if TWindow $?HidedString{Prop:Width} <= abs(xRefWTC.OptionWidth-20-5*FlagIcon#) then break.
    if FlagTrunc#
       TWindow $?HidedString{Prop:Text}=sub(TWindow $?HidedString{Prop:Text},1,len(clip(TWindow $?HidedString{Prop:Text}))-3)
    end
    TWindow $?HidedString{Prop:Text}=sub(TWindow $?HidedString{Prop:Text},1,len(clip(TWindow $?HidedString{Prop:Text}))-1)&'...'
    FlagTrunc#=TRUE
 end
 ReturnValue=clip(TWindow $?HidedString{Prop:Text})
 return ReturnValue
! *******************************************************************************************************************
TWindowMng.CreateButtons PROCEDURE
WinRef &Window
 code
 loc:WindowsList=0
 TWindow $ ?loc:WindowsList{Prop:ChoiceFeq}=?loc:WindowsList:Hide

 !   
 loop rec#=1 to records(OptionsList)
    get(OptionsList,rec#)
    TWindow $ OptionsList.FEQ{Prop:Hide} = TRUE
    TWindow $ OptionsList.FEQ{Prop:Font,4}=Font:Regular
 end
 !   ,   
 free(ChildWndList)
 loop rec#=1 to records(xRefWTC.CWQ)
    get(xRefWTC.CWQ,rec#)
    if NOT BAND(xwt_WS_DISABLED,xwt_GetWindowLong(xRefWTC.CWQ.hWnd,xwt_GWL_STYLE))=xwt_WS_DISABLED !   ,     
       count#+=1
       clear(ChildWndList)
       ChildWndList.hWnd=xRefWTC.CWQ.hWnd
       if xwt_GetWindowText(ChildWndList.hWnd,cstrCaption,SIZE(cstrCaption))
          ChildWndList.Text=clip(cstrCaption)
       end
       ChildWndList.Position=count#
       WinRef &= hWin2Win(xRefWTC.CWQ.hWnd)
       ChildWndList.Icon = WinRef{prop:icon}
       add(ChildWndList)
    end
 end
 
 !   ""  
 AllWidth#=TWindow{Prop:Width}-TWindow $ ?MoreWindows{Prop:Width}-5
 StartXpos#=6                                               !  x-

! NumButtons#=int(AllWidth#/(xRefWTC.OptionWidth+1))         ! 1 -    option-
 !   
 NumButtons#=records(ChildWndList)
 xRefWTC.OptionWidth=choose(AllWidth#/NumButtons#>150,150,int(AllWidth#/NumButtons#-1))

 !    
 SavedHandle#=0
 ChildWndList.hWnd=xwt_GetTopWindow(xRefWTC.hMDIClient)
 get(ChildWndList,ChildWndList.hWnd)
 if not errorcode()
    SavedHandle#=ChildWndList.hWnd
 end

 !  ""
 loop rec#=1 to NumButtons#
    get(OptionsList,rec#)
    if errorcode() then break.
    get(ChildWndList,rec#)
    if errorcode() then break.
    ChildWndList.FEQ = TWindow $ OptionsList.FEQ{Prop:FEQ}
    put(ChildWndList)
    TWindow $ OptionsList.FEQ{Prop:Left,2}=TRUE
    TWindow $ OptionsList.FEQ{Prop:Xpos}=StartXpos#+(rec#-1)*(xRefWTC.OptionWidth+1)
    TWindow $ OptionsList.FEQ{Prop:Ypos}=2
    TWindow $ OptionsList.FEQ{Prop:Height}=12
    TWindow $ OptionsList.FEQ{Prop:Width}=xRefWTC.OptionWidth
    TWindow $ OptionsList.FEQ{Prop:Value}=rec#
    TWindow $ OptionsList.FEQ{Prop:Flat}=TRUE
    TWindow $ OptionsList.FEQ{Prop:Icon}=ChildWndList.Icon
    FlagBold#=FALSE
    if SavedHandle#=ChildWndList.hWnd
       TWindow $ OptionsList.FEQ{Prop:Font,4}=Font:Bold
       TWindow $ OptionsList.FEQ{Prop:Font,5}=204
       loc:WindowsList=TWindow $ OptionsList.FEQ{Prop:Value}
       TWindow $ ?loc:WindowsList{Prop:ChoiceFEQ}=TWindow $ OptionsList.FEQ{Prop:FEQ}
       FlagBold#=TRUE
    end
    TWindow $ OptionsList.FEQ{Prop:Text}=SELF.CreateButtonText(clip(ChildWndList.Text),FlagBold#)
    TWindow $ OptionsList.FEQ{Prop:Tip}=clip(ChildWndList.Text)
    TWindow $ OptionsList.FEQ{Prop:Hide}=FALSE
 end

 !       " "
! if records(ChildWndList)
!    ?MoreWindows{Prop:Hide}=FALSE
! else
!    ?MoreWindows{Prop:Hide}=TRUE
! end

 display()
! *******************************************************************************************************************
TWindowMng.MoreWindows      PROCEDURE
 code
 if NOT xRefWTC.mThread !           
    xRefWTC.mThread = start(xwt_MoreWindow,25000,address(xRefWTC))
 end
! *******************************************************************************************************************
TWindowMng.ActivateWnd      PROCEDURE
 code
 loc:WindowsList=0
 TWindow $ ?loc:WindowsList{Prop:ChoiceFeq}=?loc:WindowsList:Hide
 loop rec#=1 to records(ChildWndList) !      
    get(ChildWndList,rec#)
    if ChildWndList.FEQ=0 then cycle.
    TWindow $ChildWndList.FEQ{Prop:Font,4}=Font:Regular
    TWindow $ChildWndList.FEQ{Prop:Text}=SELF.CreateButtonText(clip(ChildWndList.Text),FALSE)
 end

 ChildWndList.hWnd=xwt_GetTopWindow(xRefWTC.hMDIClient)
 get(ChildWndList,ChildWndList.hWnd)
 if not errorcode()
    if ChildWndList.FEQ<>0
       loc:WindowsList=ChildWndList.Position
       TWindow $ ?loc:WindowsList{Prop:ChoiceFeq}=ChildWndList.FEQ
       TWindow $ChildWndList.FEQ{Prop:Font,4}=Font:Bold
       TWindow $ChildWndList.FEQ{Prop:Text}=SELF.CreateButtonText(clip(ChildWndList.Text),TRUE)
    end
 end
 display()
! *******************************************************************************************************************
TWindowMng.Init             PROCEDURE
ReturnValue          BYTE,AUTO
 code
 ReturnValue = PARENT.Init()
 IF ReturnValue THEN RETURN ReturnValue.
 SELF.FirstField = ?Image
 open(TWindow)
 SELF.Opened=True
 TWindow $?Image{Prop:Text}=clip(xRefWTC.TbrIcon)        !   " " :)
 TWindow $?MoreWindows{Prop:Icon}=clip(xRefWTC.MWIcon)   !   " "
 TWindow $?loc:WindowsList:Hide{Prop:Hide}=TRUE
 TWindow $?HidedString{Prop:Hide}=TRUE
 TWindow $?HidedString{Prop:Xpos}=0
 TWindow $?HidedString{Prop:Ypos}=0
 if len(clip(xRefWTC.WallpaperName))
    TWindow{Prop:Wallpaper}=clip(xRefWTC.WallpaperName)
    case xRefWTC.WallpaperMode
       of Prop:Centered
          TWindow{Prop:Centered}=TRUE
       of Prop:Tiled
          TWindow{Prop:Tiled}=TRUE
       of Prop:Stretch
          TWindow{Prop:Stretch}=TRUE
       else
          TWindow{Prop:Centered}=TRUE
    end
 end
 SELF.ResizeToolbar()                        !       
 SELF.GetSettings()                          !     
 SELF.FillOptionsQueue()                     !   

 RETURN ReturnValue
! *******************************************************************************************************************
TWindowMng.FillOptionsQueue PROCEDURE
 code
 free(OptionsList)
 loop rec#=?loc:WL:1 to ?loc:WL:64
    OptionsList.FEQ=rec#
    add(OptionsList)
    rec#{Prop:Hide}=TRUE
 end
! *******************************************************************************************************************
TWindowMng.TakeEvent        PROCEDURE
ReturnValue          BYTE,AUTO
 code
 ReturnValue=PARENT.TakeEvent()

 CASE EVENT()
    OF Event:CloseDown OROF Event:CloseWindow
       SELF.SetSettings !     
       xRefWTC.tThread = 0
    OF Event:Sized !  
       SELF.ResizeToolbar()
       xRefWTC.UpdateToolbar()
    OF Event:Accepted
       case FIELD()
          OF ?MoreWindows
             SELF.MoreWindows()
          OF ?loc:WindowsList
             ChildWndList.Position=loc:WindowsList
             get(ChildWndList,ChildWndList.Position)
             if not errorcode()
                Err#=xwt_BringWindowToTop(ChildWndList.hWnd)
             end
             SELF.ActivateWnd()
       END
    OF Event:xwt_Update
       SELF.CreateButtons()
    OF Event:xwt_ActivateWnd
       if xRefWTC.hPrevWnd<>xwt_GetTopWindow(xRefWTC.hMDIClient)
          xRefWTC.hPrevWnd=xwt_GetTopWindow(xRefWTC.hMDIClient)
          SELF.ActivateWnd()
       end
    OF Event:AlertKey
       if keycode()=EscKey
          return 0
       end
    OF Event:xwt_HideWnd
       TWindow{Prop:Hide}=TRUE
    OF Event:xwt_UnhideWnd
       TWindow{Prop:Hide}=FALSE
    OF Event:Timer
       if xRefWTC.Timer
         if xRefWTC.Timer=1
           xRefWTC.UpdateToolbar()
         end
         xRefWTC.Timer-=1
       end
 END

 return(ReturnValue)
! *********************************************************************************
xwt_MoreWindow PROCEDURE(STRING inSelfAddr)
WList   QUEUE !  
Text       STRING(256)
hWnd       ULONG
        END

MWindow WINDOW('More windows'),AT(,,185,189),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM,DOCK(DOCK:float), |
         DOCKED(DOCK:float),SYSTEM,TOOLBOX,GRAY,DOUBLE
       STRING('Switch to window:'),AT(0,1),USE(?String1),TRN
       LIST,AT(0,12,185,158),USE(?WindowsList),VSCROLL,ALRT(MouseLeft2),FORMAT('255L(2)|M@s255@'),FROM(WList)
       BUTTON('OK'),AT(82,174,50,14),USE(?ButtonOK),DEFAULT
       BUTTON('Cancel'),AT(134,174,50,14),USE(?ButtonCancel)
     END

xRefWTC      &xWindowsToolbarClass         !    
cstrCaption  CSTRING(256)                  !  


MWindowMng   CLASS(WindowManager)                                !     
Init             PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent        PROCEDURE(),BYTE,PROC,DERIVED
FillQueue        PROCEDURE                                        !   
             END
 code
 xRefWTC &= (inSelfAddr)

 MWindowMng.Run()
! *******************************************************************************************************************
MWindowMng.Init             PROCEDURE
ReturnValue          BYTE,AUTO
 code
 ReturnValue = PARENT.Init()
 IF ReturnValue THEN RETURN ReturnValue.
 SELF.FirstField = ?WindowsList
 open(MWindow)

 xRefWTC.Translator.TranslateWindow(MWindow) ! 

 SELF.Opened=True
 ?WindowsList{Prop:LineHeight}=10
 self.FillQueue() !   
 RETURN ReturnValue
! *******************************************************************************************************************
MWindowMng.FillQueue        PROCEDURE
 code
 free(WList)
 count#=0
 loop rec#=1 to records(xRefWTC.CWQ)
    get(xRefWTC.CWQ,rec#)
    if NOT BAND(xwt_WS_DISABLED,xwt_GetWindowLong(xRefWTC.CWQ.hWnd,xwt_GWL_STYLE))=xwt_WS_DISABLED !   ,     
       clear(WList)
       count#+=1
       WList.hWnd=xRefWTC.CWQ.hWnd
       if xwt_GetWindowText(xRefWTC.CWQ.hWnd,cstrCaption,SIZE(cstrCaption))
          WList.Text=count#&': '&clip(cstrCaption)
       end
       add(WList)
    end
 end

 !     
 WList.hWnd=xwt_GetTopWindow(xRefWTC.hMDIClient)
 get(WList,WList.hWnd)
 if not errorcode()
    select(?WindowsList,pointer(WList))
 else
    select(?WindowsList,records(WList))
 end
! *******************************************************************************************************************
MWindowMng.TakeEvent        PROCEDURE
ReturnValue          BYTE,AUTO
 code
 ReturnValue=PARENT.TakeEvent()

 CASE EVENT()
    OF Event:CloseDown OROF Event:CloseWindow
       xRefWTC.mThread = 0
    OF Event:AlertKey
       if keycode()=MouseLeft2
          get(WList,choice(?WindowsList))
          if not errorcode()
             Err#=xwt_BringWindowToTop(WList.hWnd)
          end
          xRefWTC.ActivateWnd()
          post(Event:CloseWindow,,MWindow{Prop:Thread})
       end
    OF Event:Accepted
       CASE FIELD()
          OF ?ButtonOK
             get(WList,choice(?WindowsList))
             if not errorcode()
                Err#=xwt_BringWindowToTop(WList.hWnd)
             end
             xRefWTC.ActivateWnd()
             post(Event:CloseWindow,,MWindow{Prop:Thread})
          OF ?ButtonCancel
             post(Event:CloseWindow,,MWindow{Prop:Thread})
       END
 END

 return(ReturnValue)